'''
 The aim of this program is to compute statistical indicators to compare
 simulation and experiments. It is currently applied to the Prairie
 Grass experiments. The compared data are the centrelines, ie the maximum
 ground concentration on a given arc, for each arc and experiment.

'''

import atmopy
from atmopy import *
from numpy import *
from pylab import *
from stat import *


###################################################################
# Getting simulation and experimental results for each experiment.#
###################################################################

results_path = '../results/results-briggs'
exp_results_path = '../results/results-exp'
# File containing source and meteorological data.
datafile = 'exp-data.txt'

arc_list = ['ARC050', 'ARC100', 'ARC200', 'ARC400', 'ARC800']
nstation = [91, 91, 91, 91, 181]
Narc = len(arc_list)

# Getting experiment ID.
Nexp = 0
exp_num = []
rate = []
data = open(datafile)
for line in data.xreadlines():
    l = line.split()
    if l != []:
        if l[0] == 'Experiment' and int(l[1]) != 29:
            Nexp += 1
            exp_num.append(int(l[1]))
            rate.append(float(l[3])/1000.)
data.close()

# Various data to be compared.
centreline_exp = zeros((Nexp, Narc), float)
centreline_sim = zeros((Nexp, Narc), float)
concentration_tmp_exp = []
concentration_tmp_sim = []

deleted_point = []
for i in range(0, Nexp):
    print 'Experiment ' + str(exp_num[i])
    print 'Getting simulation and experimental results...'
    expfile = exp_results_path + '/exp-results-pg' + str(exp_num[i]) +'.bin'
    simfile = results_path + '/sim-results-pg' + str(exp_num[i]) +'.bin'
    concentration_exp = fromfile(expfile, dtype='float')
    concentration_sim = fromfile(simfile, dtype='float32')
    # Ground stations at different distances from source.
    min_index = 0
    for j in range(0, Narc):
        print 'Concentration on arc ' + arc_list[j]
        max_index = min_index + nstation[j]
        arcconc_exp = concentration_exp[min_index:max_index]
        arcconc_sim = concentration_sim[min_index:max_index]
        arcconc_sim = arcconc_sim[arcconc_exp >= 0.]
        arcconc_exp = arcconc_exp[arcconc_exp >= 0.]
        min_index = max_index
        # Max concentration for every arc and experiment.
        centreline_exp[i, j] = arcconc_exp.max() / rate[i]
        centreline_sim[i, j] = arcconc_sim.max() / rate[i]
